#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <d3d8.h>
#include <d3dx8math.h>

#pragma comment(lib,"msvcrt.lib")
#pragma comment(lib,"d3d8.lib")
#pragma comment(lib,"d3dx8.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(linker,"/nod:libc")

LPDIRECT3D8 p_d3d;
LPDIRECT3DDEVICE8 p_d3d_Device;
D3DDISPLAYMODE d3ddm;

#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };};
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };};
bool bIsWindowed = TRUE;

const D3DFORMAT displayFormats[6] = {
	D3DFMT_D32,
	D3DFMT_D24X8,
	D3DFMT_D24S8,
	D3DFMT_D24X4S4,
	D3DFMT_D16,
	D3DFMT_D15S1
};

LPSTR lpszFmts[6]=
{
	"D3DFMT_D32",
	"D3DFMT_D24X8",
	"D3DFMT_D24S8",
	"D3DFMT_D24X4S4",
	"D3DFMT_D16",
	"D3DFMT_D15S1"
};

char mbuf[256];

BOOL IsDepthFormatOk( D3DDEVTYPE DeviceType, D3DFORMAT AdapterFormat, D3DFORMAT DepthFormat )
{
    // Verify that the depth format exists.
    HRESULT hr = p_d3d->CheckDeviceFormat( D3DADAPTER_DEFAULT,
                                          DeviceType,
                                          AdapterFormat,
                                          D3DUSAGE_DEPTHSTENCIL,
                                          D3DRTYPE_SURFACE,
                                          DepthFormat);

    if( FAILED( hr ) ) return FALSE;

    // Verify that the depth format is compatible.
    hr = p_d3d->CheckDepthStencilMatch( D3DADAPTER_DEFAULT,
                                       DeviceType,
                                       AdapterFormat,
                                       AdapterFormat,
                                       DepthFormat);
    return SUCCEEDED( hr );
}

//int WINAPI WinMain(HINSTANCE,// Instance
//				   HINSTANCE,// Previous Instance
//				   LPSTR lpCmdLine,// Command Line Parameters
//				   int)// Window Show State
int main()
{

	p_d3d = NULL;

	p_d3d = Direct3DCreate8 (120); // D3D_SDK_VERSION

	if  (p_d3d == NULL) { MessageBox(0,"Direct3DCreate8()==NULL","",0); return 0; }

	ZeroMemory (&d3ddm, sizeof(d3ddm));

	if (p_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &d3ddm) != D3D_OK) 
	{ MessageBox(0,"p_d3d->GetAdapterDisplayMode()==NULL","",0);return 0; }

	for (unsigned int j=0;j<100;j++) // j = ADAPTER = BBUFFERFORMAT
	{

	if (p_d3d->CheckDeviceType(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,(D3DFORMAT)j,(D3DFORMAT)j,bIsWindowed) == D3D_OK)
	{
	for (unsigned int i=0;i<6;i++)
	{
    if(IsDepthFormatOk(D3DDEVTYPE_HAL, (D3DFORMAT)j,displayFormats[i]))
			printf("HAL.MODE(%u) + '%s' is OK\n",(D3DFORMAT)j,lpszFmts[i]);
//		else
//			printf("HAL.MODE(%u) + '%s' is BAD\n",(D3DFORMAT)j,lpszFmts[i]);
		//MessageBox(0,mbuf,"",0);
	}
	}

	if (p_d3d->CheckDeviceType(D3DADAPTER_DEFAULT,D3DDEVTYPE_REF,(D3DFORMAT)j,(D3DFORMAT)j,bIsWindowed) == D3D_OK)
	{
	for (unsigned int i=0;i<6;i++)
	{
    if(IsDepthFormatOk(D3DDEVTYPE_REF, (D3DFORMAT)j,displayFormats[i]))
			printf("REF.MODE(%u) + '%s' is OK\n",(D3DFORMAT)j,lpszFmts[i]);
//		else
//			printf("REF.MODE(%u) + '%s' is BAD\n",(D3DFORMAT)j,lpszFmts[i]);
		//MessageBox(0,mbuf,"",0);
	}
	}

	}
	_RELEASE_(p_d3d); _DELETE_(p_d3d);
	return 0;
}